; 

      .486                      ; create 32 bit code
      .model flat, stdcall      ; 32 bit memory model
      option casemap :none      ; case sensitive
  
;     include files
;     ~~~~~~~~~~~~~
      include \masm32\include\windows.inc
      include \masm32\include\masm32.inc
      include \masm32\include\gdi32.inc
      include \masm32\include\user32.inc
      include \masm32\include\kernel32.inc
      include \masm32\include\Comctl32.inc
      include \masm32\include\comdlg32.inc
      include \masm32\include\shell32.inc
      include \masm32\include\oleaut32.inc
      include \masm32\include\msvcrt.inc
      include \masm32\macros\macros.asm

;     libraries
;     ~~~~~~~~~
      includelib \masm32\lib\masm32.lib
      includelib \masm32\lib\gdi32.lib
      includelib \masm32\lib\user32.lib
      includelib \masm32\lib\kernel32.lib
      includelib \masm32\lib\Comctl32.lib
      includelib \masm32\lib\comdlg32.lib
      includelib \masm32\lib\shell32.lib
      includelib \masm32\lib\oleaut32.lib
      includelib \masm32\lib\msvcrt.lib

      include \masm32\include\dialogs.inc

      DlgProc PROTO :DWORD,:DWORD,:DWORD,:DWORD 

      alt_timer PROTO :DWORD,:DWORD,:DWORD,:DWORD
      alt_timer_thread PROTO :DWORD

      ALT_TIMER_THREAD STRUCT
        interval  dd ?
        idm       dd ?
        retmsg    dd ?
        hParent   dd ?
        priority  dd ?
      ALT_TIMER_THREAD ENDS

    .data
      flag      db 0

    .data?
      hWnd      dd ?
      hInstance dd ?
      counter   dd ?
      IDthread  dd ?

    .code

; 

start:
  
      mov hInstance, FUNC(GetModuleHandle,NULL)

      call main

      invoke ExitProcess,eax

; 

main proc

    Dialog "Adjustable Windows Timer", \    ; caption
           "MS Sans Serif",10, \            ; font,pointsize
            WS_OVERLAPPED or \              ; styles for
            WS_SYSMENU or DS_CENTER, \      ; dialog window
            5, \                            ; number of controls
            50,50,155,100, \                ; x y co-ordinates
            1024                            ; memory buffer size

    DlgButton "Start Timer",WS_TABSTOP,106,5,40,13,IDOK
    DlgButton "Stop Timer",WS_TABSTOP,106,20,40,13,1000
    DlgButton "Fast Timer",WS_TABSTOP,106,35,40,13,1001
    DlgButton "Slow Timer",WS_TABSTOP,106,50,40,13,1002
    DlgButton "Cancel",WS_TABSTOP,106,65,40,13,IDCANCEL

    CallModalDialog hInstance,0,DlgProc,NULL

    ret

main endp

; 

DlgProc proc hWin:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD 
 
    Switch uMsg
      Case WM_INITDIALOG
        invoke SendMessage,hWin,WM_SETICON,1,
                           FUNC(LoadIcon,NULL,IDI_ASTERISK)
        m2m hWnd, hWin
        return 1
      Case WM_COMMAND
        Switch wParam
          Case IDOK
            .if flag == 0
              mov counter, 0
              mov IDthread, rv(alt_timer,1000,1100,WM_COMMAND,hWin)
              mov byte ptr flag, 1
            .endif

          case 1000
            invoke PostThreadMessage,IDthread,WM_CLOSE,0,0
            mov counter, 0
            mov byte ptr flag,0
            invoke SetWindowText,hWin,str$(counter)

          case 1001
            invoke PostThreadMessage,IDthread,WM_COMMAND,100,10

          case 1002
            invoke PostThreadMessage,IDthread,WM_COMMAND,100,1000

          case 1100
            add counter, 1
            invoke SetWindowText,hWin,str$(counter)

          Case IDCANCEL
            jmp quit_dialog
        EndSw
      Case WM_CLOSE
        quit_dialog:
         invoke EndDialog,hWin,0
    EndSw

    return 0

DlgProc endp

; 

alt_timer proc interval:DWORD,idm:DWORD,retmsg:DWORD,hParent:DWORD

    LOCAL idnum :DWORD
    LOCAL att   :ALT_TIMER_THREAD

    .data
      attx ALT_TIMER_THREAD <0>
    .code

    m2m attx.interval, interval
    m2m attx.idm, idm
    m2m attx.retmsg, retmsg
    m2m attx.hParent, hParent
    mov attx.priority, rv(GetThreadPriority,rv(GetCurrentThread))

    invoke CreateThread,NULL,NULL,
                        ADDR alt_timer_thread,  ; thread address
                        0,                      ; structure address
                        NULL,ADDR idnum         ; thread return ID address
    mov eax, idnum
    ret

alt_timer endp

; 

alt_timer_thread proc args:DWORD

    LOCAL interval  :DWORD
    LOCAL idm       :DWORD
    LOCAL retmsg    :DWORD
    LOCAL hParent   :DWORD
    LOCAL priority  :DWORD
    LOCAL cthread   :DWORD
    LOCAL tmsg      :MSG

    m2m interval, attx.interval
    m2m idm, attx.idm
    m2m retmsg, attx.retmsg
    m2m hParent, attx.hParent
    m2m priority, attx.priority

    mov cthread, rv(GetCurrentThread)

    invoke SetThreadPriority,cthread,priority
    invoke PeekMessage,ADDR tmsg,NULL,0,0,PM_NOREMOVE

  @@:
    invoke Sleep,interval
    invoke PeekMessage,ADDR tmsg,NULL,0,0,PM_REMOVE
    test eax, eax
    jz nxt

    switch tmsg.message
      case WM_COMMAND
        switch tmsg.wParam
          case 100
            mov eax, tmsg.lParam
            mov interval, eax           ; change the interval timing on the fly
          case 101
            mov eax, tmsg.lParam
            mov idm, eax                ; change the return message ID number
          case 102
            mov eax, tmsg.lParam
            mov hParent, eax            ; change the parent handle for returned message
          case 103
            invoke SetThreadPriority,   
                   cthread,             ; change the current thread priority
                   tmsg.lParam
        endsw
      case WM_CLOSE
        jmp quit
    endsw

  nxt:
    invoke SendMessage,hParent,retmsg,idm,0
    jmp @B

  quit:
    invoke ExitThread,0
    invoke CloseHandle,cthread

    ret

alt_timer_thread endp

; 

end start
